!= Module Radiation
!
! Authors::   SUGIYAMA Ko-ichiro
! Version::   $Id: radiation_simple.f90,v 1.2 2011-05-04 17:55:15 sugiyama Exp $
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview
!
!ǥͲ׻뤿Υѥå⥸塼
!Ūˤϰʲι׻뤿δؿǼ.  
!  * 
!
!== Error Handling
!
!== Bugs
!
!== Note
!
!
!== Future Plans
!
!

module Radiation_Simple
  !
  !ǥͲ׻뤿Υѥå⥸塼
  !Ūˤϰʲι׻뤿δؿǼ.  
  !  * 
  !

  !⥸塼ɤ߹
  use dc_types, only: DP, STRING
  use dc_iounit,  only: FileOpen
  use dc_message, only: MessageNotify
  use gtool_historyauto, only: HistoryAutoAddVariable

  use mpi_wrapper,only: myrank
  use gridSet,  only: imin,     & !x β
    &                 imax,     & !x ξ
    &                 jmin,     & !y β
    &                 jmax,     & !y ξ
    &                 kmin,     & !z β
    &                 kmax        !z ξ
  use axesset,  only: z_Z         !Z ɸ(顼ʻ)
  use constants,only: DayTime     ! 1 Ĺ [s]
  use basicset, only: xyz_ExnerBZ !ʡؿδܾ

  
  !ۤηػ
  implicit none

  !private °
  private

  !ѿ
  real(DP), save, allocatable, public :: xyz_RadHeatVary(:,:,:)   !ͲǮ¸ߤΰ
  real(DP), save, allocatable, public :: xyz_RadHeatConst(:,:,:)  !ͲǮ¸ߤΰ

  public Radiation_Simple_init

contains

!!!------------------------------------------------------------------------!!!
  subroutine Radiation_Simple_init(cfgfile)
    !
    !NAMELIST Ͷ
    !

    !ۤηػ
    implicit none

    !ѿ
    character(STRING), intent(in) :: cfgfile
    real(DP)                 :: HeightUp   = 0.0d0  !ͶͿľΰξ
    real(DP)                 :: HeightDown = 0.0d0  !ͶͿľΰβ
    real(DP)                 :: RadHeatRate = 0.0d0   !ͲǮΨ [K/day]
    integer                  :: k                      !롼ѿ
    integer                  :: unit

    ! NAMELIST 
    NAMELIST /radiation_simple_nml/ RadHeatRate, HeightUp, HeightDown

    call FileOpen(unit, file=cfgfile, mode='r')
    read(unit, NML=radiation_simple_nml)
    close(unit)

    allocate( xyz_RadHeatVary(imin:imax, jmin:jmax, kmin:kmax) )
    allocate( xyz_RadHeatConst(imin:imax, jmin:jmax, kmin:kmax) )

    
    ! ̤Ͷ. 
    ! ɽ̤ RadHeight ǻꤵ줿٤ޤǤδ֤ǰѤͿ. 
    do k = kmin, kmax
      if ( z_Z(k) <= HeightDown  ) then
        xyz_RadHeatConst(:,:,k) = 0.0d0 
      elseif( z_Z(k) >= HeightUp ) then
        xyz_RadHeatConst(:,:,k) = 0.0d0 
      else
        xyz_RadHeatConst(:,:,k) = RadHeatRate / DayTime / xyz_ExnerBZ(:,:,k)
      end if
    end do
    
    ! ̤Ͷ.
    ! ɽ̤ Height1 ǻꤵ줿٤ޤǤδ֤2[K/day](RadHeatRate)
    ! ͤѤͿ.
    ! Height1  Height2 ޤǤ (Height2 - z_Z(k)) / (Height2 - Height1)
    ! γѤθ̤򸺾 (Height2Ǥ礦ɥˤ)
    ! Nakajima and Matsuno(1988),(1944)򻲹ͤˤ
    !
    do k = kmin, kmax
      if ( z_Z(k) <= HeightDown ) then
        xyz_RadHeatVary(:,:,k) = RadHeatRate / DayTime / xyz_ExnerBZ(:,:,k)
        
      elseif ( z_Z(k) > HeightDown .AND. z_Z(k) <= HeightUP) then
        xyz_RadHeatVary(:,:,k) =  &
          & RadHeatRate / DayTime / xyz_ExnerBZ(:,:,k) &
          & * (HeightUP - z_Z(k)) / (HeightUP - HeightDown) 
        
      else if (z_Z(k) > HeightUP) then
        xyz_RadHeatVary(:,:,k) = 0.0d0
      end if
    end do
     

    ! Output
    !
    if (myrank == 0) then 
      call MessageNotify( "M", &
        & "Radiation", "RadHeatRate = %f", d=(/RadHeatRate/))
      call MessageNotify( "M", &
        & "Radiation", "HeightUp = %f", d=(/HeightUP/))
      call MessageNotify( "M", &
        & "Radiation", "HeightDown= %f", d=(/HeightDown/))
    end if
    
    call HistoryAutoAddVariable(  &
      & varname='PTempRad', &
      & dims=(/'x','y','z','t'/),     &
      & longname='Radiation term of potential temperature', &
      & units='K.s-1"',    &
      & xtype='double')

  end subroutine Radiation_Simple_init

end module Radiation_Simple

